use strict;

#Einbinden im Main.pl:
#      use webFrame::readDataFromHTTP;

# Aufruf:
#     my %datenFromHTTP = readDataFromHTTP(\%datenFromENV);

# bergabe im Main.pl an eine Sub
#     main(\%datenFromHTTP);

# Empfangen in dieser sub und bearbeiten
#     my ($datenFromHTTPString) = @_;
#     foreach my $key (keys %datenFromHTTP)
#     {print ">$key< hat den Inhalt >$datenFromHTTP{$key}<\n<br>";}

###################################################################
###################################################################
## Daten einlesen

sub readDataFromHTTP
{
      ## bernahme der Parameter
      my ($datenFromENVString, $RESTRICT_DATA_FROM_HTML) = @_;
      
      ## Auspacken
      my %datenFromENV = %{$datenFromENVString};
      
      my $Daten;

      # Auswahl: Get oder Post?
      if($datenFromENV{'REQUEST_METHOD'} eq 'GET')
      {
            $Daten = $datenFromENV{'QUERY_STRING'}
      }
      else
      {
            read(STDIN, $Daten, $datenFromENV{'CONTENT_LENGTH'});
      }

      # alles in ein Array
      my @Formularfelder = split(/&/, $Daten);

      my $name;
      my $value;

      my %hashDaten;

      # aus diesem Array in ein Hash
      foreach my $Feld (@Formularfelder)
	{
            ($name, $value) = split(/=/, $Feld);

            ## Zeichen wandeln:
            $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
            
            ## aus Sicherheit werden alle nicht Buchstaben und Ziffern entfernt,
            ## wenn dieses gewnscht ist:
            if($RESTRICT_DATA_FROM_HTML eq "1"){$value =~ s/\W//g;}
            if($RESTRICT_DATA_FROM_HTML eq "2"){$value =~ s/[\\|]//g;}

            $hashDaten{$name} = $value;
      }

      return(\%hashDaten);
}

1;